unit u_nfakult;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons;

type

  { Tf_nfakult }

  Tf_nfakult = class(TForm)
    BitBtn1: TBitBtn;
    b_Berechne_nFakult: TButton;
    e_n: TEdit;
    e_ausgabe: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    procedure b_Berechne_nFakultClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  f_nfakult: Tf_nfakult;

implementation

{$R *.lfm}

{ Tf_nfakult }

procedure Tf_nfakult.b_Berechne_nFakultClick(Sender: TObject);
VAR n,fakult : INT64;

  FUNCTION nFR(n:INT64):INT64;
  BEGIN
    IF n>1 THEN nFR:=n*nFR(n-1)
           ELSE nFR:=1;
  END;

begin
 TRY					// hier folgt der Risiko-Code
  n:=STRTOINT(e_n.Text);
 EXCEPT				// hier folgt die Fehlerbehandlungsroutine
  ShowMessage('Der Eingabewert ist keine Zahl');
  e_n.Clear;                  // lösche den Eingabetext
  e_n.SetFocus;               // setze Fokus in das Eingabefeld
  EXIT;
 END;

 IF (n<0) OR (n>20) THEN
  BEGIN
   ShowMessage('Der Zahlenwert liegt nicht im Intervall [0,20]');
   e_n.Clear;
   e_n.SetFocus;
  END
                    ELSE
  BEGIN
   //Verarbeitung
   fakult:=nFR(n);
   //Ausgabe
   e_ausgabe.text:=INTTOSTR(fakult)
  END;




  {//Eingabe
  n:=STRTOINT(e_n.text);
  //Verarbeitung
  IF n<21 THEN fakult:=nFR(n)
          ELSE ShowMessage ('Die eingegebene Zahl ist zu groß');
  //Ausgabe
  e_ausgabe.text:=INTTOSTR(fakult);}
end;

end.

