unit u_nquadratsumme;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons;

type

  { Tf_nquadratsumme }

  Tf_nquadratsumme = class(TForm)
    BitBtn1: TBitBtn;
    b_berechnen: TButton;
    e_ausgabe: TEdit;
    e_eingabe: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure b_berechnenClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  f_nquadratsumme: Tf_nquadratsumme;

implementation

{$R *.lfm}

{ Tf_nquadratsumme }

procedure Tf_nquadratsumme.b_berechnenClick(Sender: TObject);
VAR n,s : INT64;

  FUNCTION quadratsumme(n:INT64):INT64;
  BEGIN
   IF n>1 THEN quadratsumme:=n*n+quadratsumme(n-1)
          ELSE quadratsumme:=1;
  END;

begin
  //Eingabe
  n := STRTOINT(e_eingabe.text);
  //Verarbeitung
  s:= quadratsumme(n);
  //Ausgabe
  e_ausgabe.text:=INTTOSTR(s);
end;

end.

